con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000  
  RX_PIN        =  30
  TX_PIN        =  31
  MODE          = %0000                                 ' see FullDuplexSerial.spin for description
  BAUD          = 9600
  num           = 63
  PAGESIZE = 32 
obj
  com   :      "FullDuplexDebug"
  i2c      : "i2cObject"
var
  byte buffer[PAGESIZE*2]
  byte  input_str[64]
  long eepromAddress 
pub Main  | i, c   
  com.start(TX_PIN,RX_PIN,MODE,BAUD)
  eepromAddress := $0000
  i2c.Initialize(i2c#bootpin)                     
  flash
pub flash | total, page, j, starttime
    com.rx
    repeat j from 0 to $7FFF step pagesize
      repeat page from 0 to num
         buffer[page]:=com.rx
      com.rxflush
      if i2c.WritePage(i2c#BootPin, i2c#EEPROM, j, @buffer, PAGESIZE*2)
        abort ' an error occured during the write
      startTime := cnt ' prepare to check for a timeout
      repeat while i2c.WriteWait(i2c#BootPin, i2c#EEPROM, j)
         if cnt - startTime > clkfreq / 10
          abort ' waited more than a 1/10 second for the write to finish
      repeat page from 0 to num
        buffer[page]:= 0    
      if i2c.ReadPage(i2c#BootPin, i2c#EEPROM, j, @buffer, PAGESIZE*2)
        abort ' an error occurred during the read
      repeat page from 0 to num step 2
        com.tx(buffer[page])
        com.tx(buffer[page+1])
      com.str(string("endofstring"))   
      com.rxflush 




              